USES crt, dos, manson;

type conrec = record
                confname     : string[16];
                confpath     : string[66];
                conffiles    : array[1..9] of string[66];
                conffhigh    : integer;
                conffreedown : boolean;
                conffilearea : boolean;
                confmsgarea  : boolean;
                confnetmail  : boolean;
                cdrom        : array[1..9] of boolean;
                confpwd      : string[15];
              end;

var udlogn          : string;
    udlogbakn       : string;
    dropn           : string;
    conffilen       : string;
    udlog           : text;
    udlogbak        : text;
    drop            : text;
    conffile        : file of conrec;
    dropb           : boolean;
    line            : string;
    downfilename    : string[12];
    downfileconf    : byte;
    nopi            : integer;
    downfileconfstr : string;
    confdata        : conrec;
    i               : integer;
    s, t            : string;
    dirfilen        : array [1..9] of string;
    newdirfilen     : array [1..9] of string;
    dirfile         : text;
    newdirfile      : text;
    dldone          : boolean;
    j               : integer;

BEGIN
  mnpceprg ('SHOW-DL V1.3','1.20');
  if paramcount <> 1 then mnhelp ('Use: SHOW-DL.EXE NODENUMMBER');
  udlogn    := getenv ('pcexpress') + '\UDLOG' + paramstr (1) + '.TXT';
  udlogbakn := getenv ('pcexpress') + '\UDLOG' + paramstr (1) + '.BAK';
  dropn     := getenv ('pcexpress') + '\SHOW-DL.SW' + paramstr (1);
  conffilen := getenv ('pcexpress') + '\CONFER.CFG';
  assign (udlog, udlogn);
  assign (udlogbak, udlogbakn);
  assign (drop, dropn);
  assign (conffile, conffilen);
  {$I-} reset (udlog); {$I+}
  if ioresult <> 0 then mnreseterr (udlogn);
  if mnexists (udlogbakn) then
    begin
      {$I-} append (udlogbak); {$I+}
      if ioresult <> 0 then mnreseterr (udlogbakn);
    end
  else
    begin
      {$I-} rewrite (udlogbak); {$I+}
      if ioresult <> 0 then mnrewriteerr (udlogbakn);
    end;
  {$I-} rewrite (drop); {$I+}
  if ioresult <> 0 then mnrewriteerr (dropn);
  dropb := false;
  repeat
    readln (udlog, line);
    writeln (udlogbak, line);
    if (pos (' down ', line) <> 0) then
      begin
        downfilename := mncutr (copy (line, (pos (' down ', line) + 6), 12));
        val (mncutr(copy(line,(pos(' conf:',line)+6),3)),downfileconf,nopi);
        writeln (drop, downfilename);
        writeln (drop, downfileconf);
        dropb := true;
      end;
  until eof(udlog);
  {$I-} close (udlog); {$I+}
  if ioresult <> 0 then mncloseerr (udlogn);
  {$I-} close (udlogbak); {$I+}
  if ioresult <> 0 then mncloseerr (udlogbakn);
  {$I-} close (drop); {$I+}
  if ioresult <> 0 then mncloseerr (dropn);
  mnerase (udlogn);
  if not dropb then mnerase (dropn);
  if dropb then
    begin
      {$I-} reset (drop); {$I+}
      if ioresult <> 0 then mnreseterr (dropn);
      repeat
        write ('.');
        readln (drop, downfilename);
        readln (drop, downfileconfstr);
        val (downfileconfstr, downfileconf, nopi);
        {$I-} reset (conffile); {$I+}
        if ioresult <> 0 then mnreseterr (conffilen);
        for i:= 1 to downfileconf do read (conffile, confdata);
        {$I-} close (conffile); {$I+}
        if ioresult <> 0 then mncloseerr (conffilen);
        for i:= 1 to 9 do
          begin
            if confdata.cdrom [i]= false then
              begin
                dirfilen[i] := confdata.conffiles[i];
                str (i, s);
                if dirfilen[i]<>'' then newdirfilen[i] := dirfilen[i]+'DIR'+s+'.SWP';
                if dirfilen[i]<>'' then dirfilen[i] := dirfilen[i]+'DIR'+s+'.TXT';
              end;
            if confdata.cdrom [i]= true then
              begin
                dirfilen[i] := confdata.conffiles[i];
                str (i, s);
                str (downfileconf,t);
                if dirfilen[i]<>'' then newdirfilen[i] := getenv('pcexpress')+'\DIR'+t+s+'.SWP';
                if dirfilen[i]<>'' then dirfilen[i] := getenv('pcexpress')+'\DIR'+t+s+'.TXT';
              end;
          end;
        for i:= 1 to 9 do
          begin
            assign (dirfile, dirfilen[i]);
            assign (newdirfile, newdirfilen[i]);
            if mnexists (dirfilen[i]) then
              begin
                {$I-} reset (dirfile); {$I+}
                if ioresult <> 0 then mnreseterr (dirfilen[i]);
                {$I-} rewrite (newdirfile); {$I+}
                if ioresult <> 0 then mnrewriteerr (dirfilen[i]);
                repeat
                  readln (dirfile, line);
                  if mncutr(copy(line,1,12))=downfilename then
                    begin
                      writeln (newdirfile, line);
                      dldone:=false;
                      repeat
                        readln (dirfile, line);
                        if ((copy(line,1,1)=' ') OR (copy(line,1,1)='.') OR (copy(line,1,1)='')) then
                          begin
                            if (copy(line,2,5)='[DL: ') then
                              begin
                                val(copy(line,7,2),j,nopi);
                                if j <> 99 then inc(j);
                                delete (line,7,2);
                                insert(mnfillup(j), line, 7);
                                writeln (newdirfile, line);
                                dldone:=true;
                              end
                            else writeln (newdirfile, line);
                          end
                        else
                          begin
                           writeln (newdirfile, ' [DL: 01]');
                           writeln (newdirfile, line);
                           dldone:=true;
                          end;
                     until dldone;
                    end
                  else writeln (newdirfile, line);
                until eof(dirfile);
                {$I-} close (dirfile); {$I+}
                if ioresult <> 0 then mncloseerr (dirfilen[i]);
                {$I-} close (newdirfile); {$I+}
                if ioresult <> 0 then mncloseerr (newdirfilen[i]);
                mnerase (dirfilen[i]);
                mnrename (newdirfilen[i], dirfilen[i]);
              end;
            end;
      until eof(drop);
      mnerase (dropn);
      writeln;
      writeln;
    end;
END.